require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_SPARC64_BITOPS_H)) {
    eval 'sub _SPARC64_BITOPS_H () {1;}' unless defined(&_SPARC64_BITOPS_H);
    require 'asm/byteorder.ph';
    eval 'sub test_and_set_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_set_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_set_bit);
    eval 'sub test_and_clear_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_clear_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_clear_bit);
    eval 'sub test_and_change_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_change_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_change_bit);
    eval 'sub set_bit {
        local($nr,$addr) = @_;
	    eval q(( &___test_and_set_bit($nr,$addr)));
    }' unless defined(&set_bit);
    eval 'sub clear_bit {
        local($nr,$addr) = @_;
	    eval q(( &___test_and_clear_bit($nr,$addr)));
    }' unless defined(&clear_bit);
    eval 'sub change_bit {
        local($nr,$addr) = @_;
	    eval q(( &___test_and_change_bit($nr,$addr)));
    }' unless defined(&change_bit);
    eval 'sub __set_bit {
        local($X,$Y) = @_;
	    eval q( &do { \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); * &__m |= (1 << ( &__nr & 63)); }  &while (0));
    }' unless defined(&__set_bit);
    eval 'sub __clear_bit {
        local($X,$Y) = @_;
	    eval q( &do { \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); * &__m &= ~(1 << ( &__nr & 63)); }  &while (0));
    }' unless defined(&__clear_bit);
    eval 'sub __change_bit {
        local($X,$Y) = @_;
	    eval q( &do { \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); * &__m ^= (1 << ( &__nr & 63)); }  &while (0));
    }' unless defined(&__change_bit);
    eval 'sub __test_and_set_bit {
        local($X,$Y) = @_;
	    eval q(({ \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); \'long __old\' = * &__m; \'long __mask\' = (1 << ( &__nr & 63)); * &__m = ( &__old |  &__mask); (( &__old &  &__mask) != 0); }));
    }' unless defined(&__test_and_set_bit);
    eval 'sub __test_and_clear_bit {
        local($X,$Y) = @_;
	    eval q(({ \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); \'long __old\' = * &__m; \'long __mask\' = (1 << ( &__nr & 63)); * &__m = ( &__old & ~ &__mask); (( &__old &  &__mask) != 0); }));
    }' unless defined(&__test_and_clear_bit);
    eval 'sub __test_and_change_bit {
        local($X,$Y) = @_;
	    eval q(({ \'unsigned long __nr\' = ; \'long\' * &__m = ( ($Y)) + ( &__nr >> 6); \'long __old\' = * &__m; \'long __mask\' = (1 << ( &__nr & 63)); * &__m = ( &__old ^  &__mask); (( &__old &  &__mask) != 0); }));
    }' unless defined(&__test_and_change_bit);
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &do { }  &while(0));
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &do { }  &while(0));
    }' unless defined(&smp_mb__after_clear_bit);
    if(defined(&ULTRA_HAS_POPULATION_COUNT)) {
    } else {
	if(1) {
	} else {
	}
    }
    if(defined(&__KERNEL__)) {
	eval 'sub ffs {
	    local($x) = @_;
    	    eval q( &generic_ffs($x));
	}' unless defined(&ffs);
	if(defined(&ULTRA_HAS_POPULATION_COUNT)) {
	} else {
	    eval 'sub hweight32 {
	        local($x) = @_;
    		eval q( &generic_hweight32($x));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        local($x) = @_;
    		eval q( &generic_hweight16($x));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        local($x) = @_;
    		eval q( &generic_hweight8($x));
	    }' unless defined(&hweight8);
	}
    }
    eval 'sub find_first_zero_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    eval 'sub test_and_set_le_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_set_le_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_set_le_bit);
    eval 'sub test_and_clear_le_bit {
        local($nr,$addr) = @_;
	    eval q(({ &___test_and_clear_le_bit($nr,$addr)!=0;}));
    }' unless defined(&test_and_clear_le_bit);
    eval 'sub set_le_bit {
        local($nr,$addr) = @_;
	    eval q(( &___test_and_set_le_bit($nr,$addr)));
    }' unless defined(&set_le_bit);
    eval 'sub clear_le_bit {
        local($nr,$addr) = @_;
	    eval q(( &___test_and_clear_le_bit($nr,$addr)));
    }' unless defined(&clear_le_bit);
    eval 'sub find_first_zero_le_bit {
        local($addr, $size) = @_;
	    eval q( &find_next_zero_le_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_le_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub ext2_set_bit () { &test_and_set_le_bit;}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit () { &test_and_clear_le_bit;}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_test_bit () { &test_le_bit;}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit () { &find_first_zero_le_bit;}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit () { &find_next_zero_le_bit;}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    local($nr,$addr) = @_;
    	    eval q( &set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    local($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
