require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__SPARC64_MMU_CONTEXT_H)) {
    eval 'sub __SPARC64_MMU_CONTEXT_H () {1;}' unless defined(&__SPARC64_MMU_CONTEXT_H);
    require 'asm/page.ph';
    if((defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0) == 13) {
	eval 'sub CTX_VERSION_SHIFT () {10;}' unless defined(&CTX_VERSION_SHIFT);
	eval 'sub TAG_CONTEXT_BITS () {0x3ff;}' unless defined(&TAG_CONTEXT_BITS);
    } else {
	eval 'sub CTX_VERSION_SHIFT () {12;}' unless defined(&CTX_VERSION_SHIFT);
	eval 'sub TAG_CONTEXT_BITS () {0xfff;}' unless defined(&TAG_CONTEXT_BITS);
    }
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/spinlock.ph';
	require 'asm/system.ph';
	require 'asm/spitfire.ph';
	eval 'sub CTX_VERSION_MASK () {((~0) <<  &CTX_VERSION_SHIFT);}' unless defined(&CTX_VERSION_MASK);
	eval 'sub CTX_FIRST_VERSION () {((1 <<  &CTX_VERSION_SHIFT) + 1);}' unless defined(&CTX_FIRST_VERSION);
	eval 'sub CTX_VALID {
	    local($__ctx) = @_;
    	    eval q((!((($__ctx) ^  &tlb_context_cache) &  &CTX_VERSION_MASK)));
	}' unless defined(&CTX_VALID);
	eval 'sub CTX_HWBITS {
	    local($__ctx) = @_;
    	    eval q((($__ctx) & ~ &CTX_VERSION_MASK));
	}' unless defined(&CTX_HWBITS);
	eval 'sub init_new_context {
	    local($__tsk, $__mm) = @_;
    	    eval q(((($__mm)-> &context = 0), 0));
	}' unless defined(&init_new_context);
	eval 'sub destroy_context {
	    local($__mm) = @_;
    	    eval q( &do {  &spin_lock( &ctx_alloc_lock);  &if ( &CTX_VALID(($__mm)-> &context)) { \'unsigned long nr\' =  &CTX_HWBITS(($__mm)-> &context);  $mmu_context_bmap[ &nr>>6] &= ~(1 << ( &nr & 63)); }  &spin_unlock( &ctx_alloc_lock); }  &while(0));
	}' unless defined(&destroy_context);
	eval 'sub reload_tlbmiss_state {
	    local($__tsk, $__mm) = @_;
    	    eval q( &do {  &register  &unsigned long paddr asm(\\"o5\\");  &register  &unsigned long pgd_cache asm(\\"o4\\");  &paddr =  &__pa(($__mm)-> &pgd);  &pgd_cache = 0;  &if (($__tsk)-> ($thread->{flags}) &  &SPARC_FLAG_32BIT)  &pgd_cache =  &pgd_val(($__mm)-> $pgd[0]) << 11;  &__asm__  &__volatile__(\\"wrpr	%%g0, 0x494, %%pstate\\\\n\\\\t\\" \\"mov	%3, %%g4\\\\n\\\\t\\" \\"mov	%0, %%g7\\\\n\\\\t\\" \\"stxa	%1, [%%g4] %2\\\\n\\\\t\\" \\"membar	#Sync\\\\n\\\\t\\" \\"wrpr	%%g0, 0x096, %%pstate\\" : : \\"r\\" ( &paddr), \\"r\\" ( &pgd_cache), \\"i\\" ( &ASI_DMMU), \\"i\\" ( &TSB_REG)); }  &while(0));
	}' unless defined(&reload_tlbmiss_state);
	eval 'sub load_secondary_context {
	    local($__mm) = @_;
    	    eval q( &__asm__  &__volatile__(\\"stxa	%0, [%1] %2\\\\n\\\\t\\" \\"flush	%%g6\\" : : \\"r\\" ( &CTX_HWBITS(($__mm)-> &context)), \\"r\\" (0x10), \\"i\\" ( &ASI_DMMU)));
	}' unless defined(&load_secondary_context);
    }
}
1;
