require '_h2ph_pre.ph';

no warnings 'redefine';

require 'linux/sched.ph';
require 'linux/interrupt.ph';
require 'linux/spinlock.ph';
unless(defined(&kernel_locked)) {
    sub kernel_locked () {
	eval q(( &spin_is_locked( &kernel_flag)  && ( ($current->{lock_depth}) >= 0)));
    }
}
unless(defined(&release_kernel_lock)) {
    sub release_kernel_lock {
	local($task, $cpu) = @_;
	eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_unlock( &kernel_flag);  &release_irqlock($cpu);  &__sti(); }  &while (0));
    }
}
unless(defined(&reacquire_kernel_lock)) {
    sub reacquire_kernel_lock {
	local($task) = @_;
	eval q( &do {  &if ( ($task->{lock_depth}) >= 0)  &spin_lock( &kernel_flag); }  &while (0));
    }
}
unless(defined(&lock_kernel)) {
    sub lock_kernel () {
	eval q( &do {  &if (!++ ($current->{lock_depth}))  &spin_lock( &kernel_flag); }  &while(0));
    }
}
unless(defined(&unlock_kernel)) {
    sub unlock_kernel () {
	eval q( &do {  &if (-- ($current->{lock_depth}) < 0)  &spin_unlock( &kernel_flag); }  &while(0));
    }
}
1;
